/** Map functions */
var AfterRender = undefined;

function RenderScript()
{
  TEXTWINDOW.drawWindow(5, 5, 70, 12);
  FONT.drawText(5, 5, "Lives: " + LIVES);
  if (typeof AfterRender == "function") AfterRender();
}


function UpdateScript()
{
  platformsystem.run();
  CheckGravity();  //Check gravity for all others.
  if (typeof updatescripts[MAP.name] == "function")
    updatescripts[MAP.name]();
}


/** Initialize any of the special map items. Eg. give enemies AI, powerups actions... */
function InitMapItems()
{
  var list = GetPersonList();
  for (p in list)
  {
    //First of all, move everything half their width to the right and bottom.
    SetPersonX(list[p], GetPersonX(list[p]) + GetPersonBase(list[p]).x2/4);
    
    if (GetPersonBase(list[p]).y2 > 16)
      SetPersonY(list[p], GetPersonY(list[p]) + 6);
    
    if (list[p].slice(0, 16) == "powerup-strength")
    {
      //Destroy any that the player has already gotten.
      for (n in STRENGTH_POWERUPS)
      {
        if (list[p].slice(17, list[p].length) == STRENGTH_POWERUPS[n])
          DestroyPerson(list[p]);
      }
    }
  }
}


/** Check the gravity of all persons on the map and let them fall down if necessary. */
function CheckGravity()
{
  var list = GetPersonList();
  for (p in list)
  {
    if (list[p].slice(0, 3) == "box")
    {
      if (!IsPersonObstructed(list[p], GetPersonX(list[p]), GetPersonY(list[p])+2))
        SetPersonY(list[p], GetPersonY(list[p])+2);
      
      //else if (!IsPersonObstructed(list[p], GetPersonX(list[p]), GetPersonY(list[p])+1))
        //SetPersonY(list[p], GetPersonY(list[p])+1);
    }
  }
}

/** Simple map transport function. */
function Warp(map, x, y)
{
  ChangeMap(map);
  MAP.name = map;
  platformsystem.enterx = x*16;
  platformsystem.entery = y*16;
  SetPersonX(platformsystem.person, x*16);
  SetPersonY(platformsystem.person, y*16);
}



/*********************/
// MAP UPDATESCRIPTS
/*********************/
//Used for map-specific events (like stuff that can't be done through triggers).
updatescripts = [];

